<script>
  var plotLayout = [
    % i,j = 0, 0
    % totalHeight = 0
    % for plot in plots:
    %   if plot['value'] == 'checked':
    %     grid = plot['grid'].copy() if 'grid' in plot else {'x':0, 'y':0, 'w':12, 'h':4}
    %     grid['y'] = totalHeight
    %     grid['i'] = i
    %     grid['title'] = plot['title']
    %     grid['divname'] = 'plot'+`j+1`
    %     grid['type'] = plot['type']
          {{!grid}},
    %     totalHeight += grid['h']
    %     i += 1
    %   end
    %   j += 1
    % end
  ];

  function disableSelect(event) {
    event.preventDefault();
  }

  new Vue({
    el: '#plots',
    data() {
      return {
        layout: plotLayout,
        analysis: false,
        responsive: true,
        draggable: true,
        resizable: true,
        modalShow: false,
      }
    },
    methods: {
      resizeEvent: function(){
        window.addEventListener('selectstart', disableSelect);
      },
      resizedEvent: function() {
        window.removeEventListener('selectstart', disableSelect);
      },
      moveEvent: function(){
        window.addEventListener('selectstart', disableSelect);
      },
      movedEvent: function(){
        window.removeEventListener('selectstart', disableSelect);
      },
      deleteItem: function(item, plot){
        eval(plot).okay_to_draw = false;
        var width = this.layout[item]['w'];
        var height = this.layout[item]['h'];
        var ySpace = this.layout[item]['y'] + height;
        if (width == 12){
          for (var i = 0; i < this.layout.length; i++) {
            if (this.layout[i]['y'] >= ySpace) {
              this.layout[i]['y'] -= height
            }
          }
        }
        for (var key in this.layout[item]) {
          this.layout[item][key] = null;
        }
        eval('grid'+plot).remove();
      },
      addItem: function(plot, type){
        totalHeight = 0;
        for (var i = 0; i < this.layout.length; i++) {
          if (this.layout[i]['divname'] == plot.divname) {
            this.modalShow = true;
            return
          }
          totalHeight += this.layout[i]['h']
        }
        i = this.layout.length;
        gridItem = JSON.parse(JSON.stringify(plot.grid));
        gridItem['i'] = i
        gridItem['y'] = totalHeight;
        gridItem['title'] = plot.title;
        gridItem['divname'] = plot.divname;
        gridItem['type'] = type.name;
        this.layout.push(gridItem);
        plot.okay_to_draw = true;
        plot.populate();
      },
    },
    watch: {
      analysis: function() {
        this.draggable = !this.draggable;
        this.resizable = !this.resizable;
      },
    }
  });

  % import json
  % for ii, plot in enumerate(plots, 1):
  %   plot_id = 'plot'+`ii`
  %   plot_title = plot['title']
  %   plot_grid = plot['grid'] if 'grid' in plot else {'x':0, 'y':0, 'w':12, 'h':4}
  %   schema = json.dumps(plot['schema'])
  %   plot_layout = plot['layout'] if 'layout' in plot else {}
  %   plot_options = plot['options'] if 'options' in plot else {}
  %   plot_data_options = plot['data_options'] if 'data_options' in plot else {}
  %   data_segment = {"start":  start, "stop": stop}
        var plot{{ii}} = new {{plot['type']}}(
          "{{plot_id}}",              // div name for the plot
          '{{plot_title}}',           // plot title stored for regeneration
          '{{plot['measurement']}}',  // name of measurement to query
          {{!schema}},                // schema for retrieving data
          '{{script_name}}',          // script name (hack to deal with cgi/apache)
          {{!data_segment}},          // initial data segment
          {{refresh}},                // refresh interval in ms, -1 to disable refresh
          {{!plot_data_options}},     // custom plot data options, provided as a dict
          {{!plot_grid}},             // custom grid item for vue grid layout
          {{!plot_layout}},           // custom plot layout, provided as a dict
          {{!plot_options}},          // custom plot options, provided as a dict
          {{delay}},                  // sets delay for realtime data
        );
  %   if plot['value'] == 'checked':
        plot{{ii}}.populate();
  %   end
  % end

  document.body.onkeydown = function(e) {
    if (e.keyCode == 32) {
      e.preventDefault();
    }
  };

  document.body.onkeyup = function(e){
    if(e.keyCode == 32){
      var i;
      for (i = 0; i < _global_plots.length; i++) {
        _global_plots[i].toggle_interval();
      }
    }
  };

  var FAR_Table = new Vue({
    el: '#table',
    data() {
      return {
        isHidden: true,
        search: '',
        filter: null,
        dataTrack: false,
        sortBy: 'ifar',
        sortDesc: true,
        totalRows: null,
        perPage:6,
        currentPage: 1,
        items: [],
        fields: {
          measurement: {label: 'Measurement',sortable: true,},
          startTime: {label: 'Start Time',sortable: true,},
          endTime: {label: 'End Time',sortable:true,},
          ifar: {label: 'IFAR', sortable: true,},
          value: {label: 'Number of Events',sortable: true,},
          H1chi: {label: 'H1 \u03c72',sortable: true,},
          L1chi: {label: 'L1 \u03c72',sortable: true,},
          V1chi: {label: 'V1 \u03c72',sortable: true,},
          mass1: {label: 'Mass 1',sortable: true,},
          mass2: {label: 'Mass 2',sortable: true,},
          spin1: {label: 'Spin 1',sortable: true,},
          spin2: {label: 'Spin 2',sortable: true,},
        },
        items: [],
      }
    },
    watch: {
      dataTrack: function() {
        if (!this.dataTrack) {
          this.currentPage = 1;
        }
      },
      filter: function() {
        this.dataTrack = false;
        this.currentPage = 1;
      },
    },
  });
</script>